/**
 * LINE Messaging API
 * This document describes LINE Messaging API.
 *
 * The version of the OpenAPI document: 0.0.1
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

//go:generate python3 ../../generate-code.py
package messaging_api

import (
	"time"
)

// NarrowcastProgressResponse
// NarrowcastProgressResponse
// https://developers.line.biz/en/reference/messaging-api/#get-narrowcast-progress-status
type NarrowcastProgressResponse struct {

	/**
	 * The current status. One of:  `waiting`: Messages are not yet ready to be sent. They are currently being filtered or processed in some way. `sending`: Messages are currently being sent. `succeeded`: Messages were sent successfully. This may not mean the messages were successfully received. `failed`: Messages failed to be sent. Use the failedDescription property to find the cause of the failure.  (Required)
	 */
	Phase NarrowcastProgressResponsePHASE `json:"phase"`

	/**
	 * The number of users who successfully received the message.
	 */
	SuccessCount int64 `json:"successCount"`

	/**
	 * The number of users who failed to send the message.
	 */
	FailureCount int64 `json:"failureCount"`

	/**
	 * The number of intended recipients of the message.
	 */
	TargetCount int64 `json:"targetCount"`

	/**
	 * The reason the message failed to be sent. This is only included with a `phase` property value of `failed`.
	 */
	FailedDescription string `json:"failedDescription,omitempty"`

	/**
	 * Error summary. This is only included with a phase property value of failed. One of:  `1`: An internal error occurred. `2`: An error occurred because there weren&#39;t enough recipients. `3`: A conflict error of requests occurs because a request that has already been accepted is retried.
	 */
	ErrorCode int64 `json:"errorCode"`

	/**
	 * Narrowcast message request accepted time in milliseconds.  Format: ISO 8601 (e.g. 2020-12-03T10:15:30.121Z) Timezone: UTC  (Required)
	 */
	AcceptedTime time.Time `json:"acceptedTime"`

	/**
	 * Processing of narrowcast message request completion time in milliseconds. Returned when the phase property is succeeded or failed.  Format: ISO 8601 (e.g. 2020-12-03T10:15:30.121Z) Timezone: UTC
	 */
	CompletedTime time.Time `json:"completedTime,omitempty"`
}

// NarrowcastProgressResponsePHASE type
/* The current status. One of:  `waiting`: Messages are not yet ready to be sent. They are currently being filtered or processed in some way. `sending`: Messages are currently being sent. `succeeded`: Messages were sent successfully. This may not mean the messages were successfully received. `failed`: Messages failed to be sent. Use the failedDescription property to find the cause of the failure.  */
type NarrowcastProgressResponsePHASE string

// NarrowcastProgressResponsePHASE constants
const (
	NarrowcastProgressResponsePHASE_WAITING NarrowcastProgressResponsePHASE = "waiting"

	NarrowcastProgressResponsePHASE_SENDING NarrowcastProgressResponsePHASE = "sending"

	NarrowcastProgressResponsePHASE_SUCCEEDED NarrowcastProgressResponsePHASE = "succeeded"

	NarrowcastProgressResponsePHASE_FAILED NarrowcastProgressResponsePHASE = "failed"
)
